package net.afyre.haha.demo.rcp;

import java.util.HashSet;
import java.util.Set;

import net.afyre.haha.demo.rcp.hacks.DisabledHandler;

import org.eclipse.core.commands.Command;
//import org.eclipse.core.commands.ExecutionEvent;
//import org.eclipse.core.commands.ExecutionException;
//import org.eclipse.core.commands.IExecutionListener;
//import org.eclipse.core.commands.NotHandledException; 
import org.eclipse.core.runtime.ILog;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.application.IWorkbenchWindowConfigurer;
import org.eclipse.ui.application.WorkbenchAdvisor;
import org.eclipse.ui.application.WorkbenchWindowAdvisor;
import org.eclipse.ui.commands.ICommandService;
import org.eclipse.ui.contexts.IContextService;
//import org.eclipse.ui.handlers.IHandlerService;

public class ApplicationWorkbenchAdvisor extends WorkbenchAdvisor {

  private final ILog log = Activator.getDefault().getLog();
  
  private static final String PERSPECTIVE_ID = "net.afyre.haha.demo.rcp.perspective"; //$NON-NLS-1$

  private static final String[] commandBlacklist = new String[] {
    //"org.eclipse.ui.newWizard"
  };
  
  public WorkbenchWindowAdvisor createWorkbenchWindowAdvisor(
      IWorkbenchWindowConfigurer configurer) {
    return new ApplicationWorkbenchWindowAdvisor(configurer);
  }

  public String getInitialWindowPerspectiveId() {
    return PERSPECTIVE_ID;
  } 
  
  @Override
  public void postStartup() {
    super.postStartup();
    
    IContextService contextService = (IContextService) PlatformUI.getWorkbench().getService(IContextService.class);
    contextService.activateContext("eclipse.sucks");
    
    final Set<String> blacklist = new HashSet<String>(commandBlacklist.length);
    for (final String id : commandBlacklist) {
      blacklist.add(id);
    }
    
    final IWorkbench workbench = getWorkbenchConfigurer().getWorkbench();
    final ICommandService commandService = 
        (ICommandService) workbench.getService(ICommandService.class);
    for (final Command cmd : commandService.getDefinedCommands()) {
      if (blacklist.contains(cmd.getId())) {
        log.log(new Status(IStatus.INFO, Activator.PLUGIN_ID, 
            "Disabling handler for command: " + cmd.getId()));
        cmd.setHandler(DisabledHandler.getInstance());
      }
      /*cmd.addExecutionListener(new IExecutionListener() {
        
        @Override
        public void preExecute(String commandId, ExecutionEvent event) {
          log.log(new Status(IStatus.INFO, Activator.PLUGIN_ID, 
              "Executing command " + commandId));
        }
        
        @Override
        public void postExecuteSuccess(String commandId, Object returnValue) {
          // TODO Auto-generated method stub
          
        }
        
        @Override
        public void postExecuteFailure(String commandId, ExecutionException exception) {
          // TODO Auto-generated method stub
          
        }
        
        @Override
        public void notHandled(String commandId, NotHandledException exception) {
          // TODO Auto-generated method stub
          
        }
      });*/
    }
  }
  
}
