package net.afyre.haha.demo.rcp;

import java.util.Iterator;

import org.eclipse.e4.ui.model.application.ui.SideValue;
import org.eclipse.e4.ui.model.application.ui.basic.MTrimBar;
import org.eclipse.e4.ui.model.application.ui.basic.MTrimElement;
import org.eclipse.e4.ui.model.application.ui.basic.MTrimmedWindow;
import org.eclipse.e4.ui.model.application.ui.basic.MWindow;
import org.eclipse.e4.ui.model.application.ui.menu.MToolControl;
import org.eclipse.e4.ui.workbench.modeling.EModelService;
import org.eclipse.swt.graphics.Point;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.application.ActionBarAdvisor;
import org.eclipse.ui.application.IActionBarConfigurer;
import org.eclipse.ui.application.IWorkbenchWindowConfigurer;
import org.eclipse.ui.application.WorkbenchWindowAdvisor;
import org.eclipse.ui.internal.WorkbenchWindow;

@SuppressWarnings("restriction")
public class ApplicationWorkbenchWindowAdvisor extends WorkbenchWindowAdvisor {

  public ApplicationWorkbenchWindowAdvisor(IWorkbenchWindowConfigurer configurer) {
    super(configurer);
  }

  public ActionBarAdvisor createActionBarAdvisor(IActionBarConfigurer configurer) {
    return new ApplicationActionBarAdvisor(configurer);
  }

  public void preWindowOpen() {
    IWorkbenchWindowConfigurer configurer = getWindowConfigurer();
    configurer.setInitialSize(new Point(400, 300));
    configurer.setShowCoolBar(true);
    configurer.setShowStatusLine(true);
  }
  
  // See https://bugs.eclipse.org/bugs/show_bug.cgi?id=362420
  @Override
  public void openIntro() {
    final IWorkbenchWindowConfigurer configurer = getWindowConfigurer();
      IWorkbenchWindow window = configurer.getWindow();
      MWindow model = ((WorkbenchWindow) window).getModel();
      EModelService modelService = model.getContext()
              .get(EModelService.class);
      MTrimBar trimBar = modelService.getTrim((MTrimmedWindow) model,
              SideValue.TOP);
      Iterator<MTrimElement> it = trimBar.getChildren().iterator();
      while (it.hasNext()) {
          MTrimElement next = it.next();
          if (next instanceof MToolControl)
              next.setToBeRendered(false);

      }
      super.openIntro();
  }
}
