package net.afyre.haha.demo.solver.context;

import net.afyre.haha.demo.solver.expr.formulae.Formula;

/**
 * Declaration of an axiom.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public final class AxiomDeclaration extends AbstractDeclaration {
  /** Asserted formula. */
  private final Formula axiom;
  
  /**
   * Constructor.
   * @param name Axiom name.
   * @param axiom Asserted formula.
   */
  public AxiomDeclaration(final String name,
                          final Formula axiom) {
    super(name);
    this.axiom = axiom;
  }
  
  /** {@inheritDoc} */
  @Override
  public void accept(final DeclarationVisitor visitor) {
    visitor.visitAxiom(getName(), axiom);
  }
}
