package net.afyre.haha.demo.solver.dummy;

import net.afyre.haha.demo.solver.context.Answer;
import net.afyre.haha.demo.solver.context.Declaration;
import net.afyre.haha.demo.solver.context.SolverContext;
import net.afyre.haha.demo.solver.expr.formulae.Formula;

/**
 * This is a dummy solver that does not do anything.
 *
 * @author Aleksy Schubert <alx@mimuw.edu.pl>
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 *
 */
public class DummySolver implements SolverContext {
  /**
   * This is a dummy implementation that does not do anything.
   * 
   * @param declaration Ignored.
   * @return {@code true}.
   */
  @Override
  public boolean addDeclaration(final Declaration declaration) { 
    return true;
  }
  
  /**
   * This is a dummy implementation that does not do anything.
   * @return {@code true}.
   */
  @Override  
  public boolean mark() { 
    return true;
  }
  
  /**
   * This is a dummy implementation that does not do anything.
   * @return {@code true}.
   */
  @Override   
  public boolean reset() { 
    return true;
  }
  
  /**
   * This is a dummy implementation that always answers @link{Anser.UNKNOWN}.
   * 
   * @param query The formula (ignored).
   * @return Answer.UNKNOWN
   */
  @Override
  public Answer isValid(final Formula query) {
    return Answer.UNKNOWN;
  }

  /**
   * This is a dummy implementation that always answers @link{Anser.UNKNOWN}.
   * 
   * @param query the formula (ignored).
   * @return Answer.UNKNOWN
   */
  @Override
  public Answer isSatisfiable(final Formula query) {
    return Answer.UNKNOWN;
  }

  /** Ignored. */
  @Override
  public void finish() { }
  
}
