package net.afyre.haha.demo.solver.expr.formulae.impl;

import net.afyre.haha.demo.solver.expr.terms.Term;

/**
 * Abstract superclass of formulae which
 * are some form of comparison between two terms.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 *
 */
public abstract class Comparison extends AbstractFormula {
  /** Left term. */
  private final Term left;
  
  /** Right term. */
  private final Term right;
  
  /**
   * Constructor.
   * @param left Left operand.
   * @param right Right operand.
   */
  protected Comparison(final Term left, final Term right) {
    this.left = left;
    this.right = right;
  }

  /**
   * Get the left term.
   * @return The left term.
   */
  public Term getLeft() {
    return left;
  }

  /**
   * Get the right term.
   * @return The right term.
   */
  public Term getRight() {
    return right;
  }
}
