package net.afyre.haha.demo.solver.expr.impl;

import java.math.BigInteger;

import net.afyre.haha.demo.solver.expr.Expression;
import net.afyre.haha.demo.solver.expr.ExpressionFactory;
import net.afyre.haha.demo.solver.expr.VariableBinding;
import net.afyre.haha.demo.solver.expr.formulae.Formula;
import net.afyre.haha.demo.solver.expr.formulae.impl.Conjunction;
import net.afyre.haha.demo.solver.expr.formulae.impl.Disjunction;
import net.afyre.haha.demo.solver.expr.formulae.impl.Distinct;
import net.afyre.haha.demo.solver.expr.formulae.impl.Eq;
import net.afyre.haha.demo.solver.expr.formulae.impl.Equivalence;
import net.afyre.haha.demo.solver.expr.formulae.impl.Exists;
import net.afyre.haha.demo.solver.expr.formulae.impl.FLet;
import net.afyre.haha.demo.solver.expr.formulae.impl.FLetProp;
import net.afyre.haha.demo.solver.expr.formulae.impl.False;
import net.afyre.haha.demo.solver.expr.formulae.impl.Forall;
import net.afyre.haha.demo.solver.expr.formulae.impl.FormulaVariable;
import net.afyre.haha.demo.solver.expr.formulae.impl.Ge;
import net.afyre.haha.demo.solver.expr.formulae.impl.Gt;
import net.afyre.haha.demo.solver.expr.formulae.impl.Implication;
import net.afyre.haha.demo.solver.expr.formulae.impl.Le;
import net.afyre.haha.demo.solver.expr.formulae.impl.Lt;
import net.afyre.haha.demo.solver.expr.formulae.impl.Negation;
import net.afyre.haha.demo.solver.expr.formulae.impl.Neq;
import net.afyre.haha.demo.solver.expr.formulae.impl.PredicateCall;
import net.afyre.haha.demo.solver.expr.formulae.impl.True;
import net.afyre.haha.demo.solver.expr.formulae.impl.Xor;
import net.afyre.haha.demo.solver.expr.terms.Term;
import net.afyre.haha.demo.solver.expr.terms.impl.Addition;
import net.afyre.haha.demo.solver.expr.terms.impl.ArrayAccess;
import net.afyre.haha.demo.solver.expr.terms.impl.ArrayUpdate;
import net.afyre.haha.demo.solver.expr.terms.impl.Call;
import net.afyre.haha.demo.solver.expr.terms.impl.Concat;
import net.afyre.haha.demo.solver.expr.terms.impl.Division;
import net.afyre.haha.demo.solver.expr.terms.impl.IfThenElse;
import net.afyre.haha.demo.solver.expr.terms.impl.IntConst;
import net.afyre.haha.demo.solver.expr.terms.impl.Let;
import net.afyre.haha.demo.solver.expr.terms.impl.LetProp;
import net.afyre.haha.demo.solver.expr.terms.impl.MkTuple;
import net.afyre.haha.demo.solver.expr.terms.impl.Multiplication;
import net.afyre.haha.demo.solver.expr.terms.impl.Power;
import net.afyre.haha.demo.solver.expr.terms.impl.Remainder;
import net.afyre.haha.demo.solver.expr.terms.impl.Repeat;
import net.afyre.haha.demo.solver.expr.terms.impl.RotateLeft;
import net.afyre.haha.demo.solver.expr.terms.impl.RotateRight;
import net.afyre.haha.demo.solver.expr.terms.impl.SX;
import net.afyre.haha.demo.solver.expr.terms.impl.SelectBits;
import net.afyre.haha.demo.solver.expr.terms.impl.Shl;
import net.afyre.haha.demo.solver.expr.terms.impl.Shr;
import net.afyre.haha.demo.solver.expr.terms.impl.Subtraction;
import net.afyre.haha.demo.solver.expr.terms.impl.TupleAccess;
import net.afyre.haha.demo.solver.expr.terms.impl.Uminus;
import net.afyre.haha.demo.solver.expr.terms.impl.Variable;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorAnd;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorCmp;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorDiff;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorGe;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorGt;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorLe;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorLshr;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorLt;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorNand;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorNor;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorOr;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorProd;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorRshr;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorSdiv;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorSge;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorSgt;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorShl;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorSle;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorSlt;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorSmod;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorSrem;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorSum;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorUdiv;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorUminus;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorUrem;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorXnor;
import net.afyre.haha.demo.solver.expr.terms.impl.VectorXor;
import net.afyre.haha.demo.solver.expr.terms.impl.ZeroExtend;
import net.afyre.haha.demo.solver.expr.types.AtomicType;
import net.afyre.haha.demo.solver.expr.types.NonValueType;
import net.afyre.haha.demo.solver.expr.types.StructuredType;
import net.afyre.haha.demo.solver.expr.types.ValueType;
import net.afyre.haha.demo.solver.expr.types.impl.Array;
import net.afyre.haha.demo.solver.expr.types.impl.Bitvector;
import net.afyre.haha.demo.solver.expr.types.impl.Function;
import net.afyre.haha.demo.solver.expr.types.impl.Int;
import net.afyre.haha.demo.solver.expr.types.impl.Predicate;
import net.afyre.haha.demo.solver.expr.types.impl.Prop;
import net.afyre.haha.demo.solver.expr.types.impl.Rational;
import net.afyre.haha.demo.solver.expr.types.impl.Tuple;

/**
 * Trivial implementation of an expression factory.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public final class SimpleExpressionFactory implements ExpressionFactory {
  /** {@inheritDoc} */
  @Override
  public Term createIntConst(final BigInteger value) {
    return new IntConst(value);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVariable(final String var) {
    return new Variable(var);
  }

  /** {@inheritDoc} */
  @Override
  public Term createMkTuple(final Term... elements) {
    return new MkTuple(elements);
  }

  /** {@inheritDoc} */
  @Override
  public Term createTupleAccess(final Term tuple, final int index) {
    return new TupleAccess(tuple, index);
  }

  /** {@inheritDoc} */
  @Override
  public Term createUminus(final Term arg) {
    return new Uminus(arg);
  }

  /** {@inheritDoc} */
  @Override
  public Term createAddition(final Term left, final Term right) {
    return new Addition(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createSubtraction(final Term left, final Term right) {
    return new Subtraction(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createMultiplication(final Term left, final Term right) {
    return new Multiplication(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createDivision(final Term left, final Term right) {
    return new Division(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createRemainder(final Term left, final Term right) {
    return new Remainder(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createPower(final Term left, final Term right) {
    return new Power(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createLet(final String var,
                        final ValueType type,
                        final Term value,
                        final Term body) {
    return new Let(var, type, value, body);
  }

  /** {@inheritDoc} */
  @Override
  public Term createLetProp(final String var,
                            final Formula value,
                            final Term body) {
    return new LetProp(var, value, body);
  }

  /** {@inheritDoc} */
  @Override
  public Term createIfThenElse(final Formula cond,
                               final Term ifTrue,
                               final Term ifFalse) {
    return new IfThenElse(cond, ifTrue, ifFalse);
  }

  /** {@inheritDoc} */
  @Override
  public Term createArrayAccess(final Term arr, final Term index) {
    return new ArrayAccess(arr, index);
  }

  /** {@inheritDoc} */
  @Override
  public Term createArrayUpdate(final Term arr,
                                final Term index,
                                final Term value) {
    return new ArrayUpdate(arr, index, value);
  }

  /** {@inheritDoc} */
  @Override
  public Term createCall(final String func, final Term... args) {
    return new Call(func, args);
  }

  /** {@inheritDoc} */
  @Override
  public Term createConcat(final Term left, final Term right) {
    return new Concat(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createSelectBits(final Term vec,
                               final int left,
                               final int right) {
    return new SelectBits(vec, left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createShl(final Term vec, final int offset) {
    return new Shl(vec, offset);
  }

  /** {@inheritDoc} */
  @Override
  public Term createShr(final Term vec, final int offset) {
    return new Shr(vec, offset);
  }

  /** {@inheritDoc} */
  @Override
  public Term createSX(final Term vec, final int offset) {
    return new SX(vec, offset);
  }

  /** {@inheritDoc} */
  @Override
  public Term createZeroExtend(final Term vec, final int offset) {
    return new ZeroExtend(vec, offset);
  }

  /** {@inheritDoc} */
  @Override
  public Term createRepeat(final Term vec, final int count) {
    return new Repeat(vec, count);
  }

  /** {@inheritDoc} */
  @Override
  public Term createRotateLeft(final Term vec, final int offset) {
    return new RotateLeft(vec, offset);
  }

  /** {@inheritDoc} */
  @Override
  public Term createRotateRight(final Term vec, final int offset) {
    return new RotateRight(vec, offset);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorAnd(final Term left, final Term right) {
    return new VectorAnd(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorOr(final Term left, final Term right) {
    return new VectorOr(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorXor(final Term left, final Term right) {
    return new VectorXor(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorNand(final Term left, final Term right) {
    return new VectorNand(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorNor(final Term left, final Term right) {
    return new VectorNor(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorXnor(final Term left, final Term right) {
    return new VectorXnor(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorCmp(final Term left, final Term right) {
    return new VectorCmp(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorSum(final Term left, final Term right) {
    return new VectorSum(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorDiff(final Term left, final Term right) {
    return new VectorDiff(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorUminus(final Term vec) {
    return new VectorUminus(vec);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorProd(final Term left, final Term right) {
    return new VectorProd(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorShl(final Term vec, final Term offset) {
    return new VectorShl(vec, offset);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorLshr(final Term vec, final Term offset) {
    return new VectorLshr(vec, offset);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorRshr(final Term vec, final Term offset) {
    return new VectorRshr(vec, offset);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorUdiv(final Term left, final Term right) {
    return new VectorUdiv(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorSdiv(final Term left, final Term right) {
    return new VectorSdiv(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorUrem(final Term left, final Term right) {
    return new VectorUrem(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorSrem(final Term left, final Term right) {
    return new VectorSrem(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorSmod(final Term left, final Term right) {
    return new VectorSmod(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorLt(final Term left, final Term right) {
    return new VectorLt(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorGt(final Term left, final Term right) {
    return new VectorGt(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorLe(final Term left, final Term right) {
    return new VectorLe(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorGe(final Term left, final Term right) {
    return new VectorGe(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorSlt(final Term left, final Term right) {
    return new VectorSlt(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorSgt(final Term left, final Term right) {
    return new VectorSgt(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorSle(final Term left, final Term right) {
    return new VectorSle(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Term createVectorSge(final Term left, final Term right) {
    return new VectorSge(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public StructuredType createArray(final ValueType indexType,
                                    final ValueType valueType) {
    return new Array(indexType, valueType);
  }

  /** {@inheritDoc} */
  @Override
  public StructuredType createTuple(final ValueType... types) {
    return new Tuple(types);
  }

  /** {@inheritDoc} */
  @Override
  public AtomicType createRational() {
    return new Rational();
  }

  /** {@inheritDoc} */
  @Override
  public AtomicType createInt() {
    return new Int();
  }

  /** {@inheritDoc} */
  @Override
  public AtomicType createBitvector(final int size) {
    return new Bitvector(size);
  }

  /** {@inheritDoc} */
  @Override
  public NonValueType createProp() {
    return new Prop();
  }

  /** {@inheritDoc} */
  @Override
  public NonValueType createFunction(final ValueType resultType,
                                     final ValueType... argTypes) {
    return new Function(resultType, argTypes);
  }

  /** {@inheritDoc} */
  @Override
  public NonValueType createPredicate(final ValueType... argTypes) {
    return new Predicate(argTypes);
  }

  /** {@inheritDoc} */
  @Override
  public Formula createTrue() {
    return new True();
  }

  /** {@inheritDoc} */
  @Override
  public Formula createFalse() {
    return new False();
  }

  /** {@inheritDoc} */
  @Override
  public Formula createFormulaVariable(final String name) {
    return new FormulaVariable(name);
  }

  /** {@inheritDoc} */
  @Override
  public Formula createNegation(final Formula arg) {
    return new Negation(arg);
  }

  /** {@inheritDoc} */
  @Override
  public Formula createConjunction(final Formula left,
                                   final Formula right) {
    return new Conjunction(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Formula createDisjunction(final Formula left,
                                   final Formula right) {
    return new Disjunction(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Formula createImplication(final Formula left,
                                   final Formula right) {
    return new Implication(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Formula createXor(final Formula left, final Formula right) {
    return new Xor(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Formula createEquivalence(final Formula left,
                                   final Formula right) {
    return new Equivalence(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Formula createEq(final Term left, final Term right) {
    return new Eq(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Formula createNeq(final Term left, final Term right) {
    return new Neq(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Formula createDistinct(final Term... args) {
    return new Distinct(args);
  }

  /** {@inheritDoc} */
  @Override
  public Formula createLt(final Term left, final Term right) {
    return new Lt(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Formula createGt(final Term left, final Term right) {
    return new Gt(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Formula createLe(final Term left, final Term right) {
    return new Le(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Formula createGe(final Term left, final Term right) {
    return new Ge(left, right);
  }

  /** {@inheritDoc} */
  @Override
  public Formula createExists(final Iterable<VariableBinding> variables,
                              final Formula arg, 
                              final Expression... patterns) {
    return new Exists(variables, arg, patterns);
  }

  /** {@inheritDoc} */
  @Override
  public Formula createForall(final Iterable<VariableBinding> variables,
                              final Formula arg,
                              final Expression... patterns) {
    return new Forall(variables, arg, patterns);
  }

  /** {@inheritDoc} */
  @Override
  public Formula createFLet(final String var,
                            final ValueType type,
                            final Term value,
                            final Formula body) {
    return new FLet(var, type, value, body);
  }

  /** {@inheritDoc} */
  @Override
  public Formula createFLetProp(final String var,
                                final Formula value,
                                final Formula body) {
    return new FLetProp(var, value, body);
  }

  @Override
  public Formula createPredicateCall(final String pred, 
                                     final Term... args) {
    return new PredicateCall(pred, args);
  }
}
