package net.afyre.haha.demo.solver.expr.terms.impl;

import net.afyre.haha.demo.solver.expr.terms.Term;
import net.afyre.haha.demo.solver.expr.terms.TermSwitch;

/**
 * Sign extension.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */

public final class SX extends VectorOffsetOp {
 /**
   * Constructor.
   * @param vector Vector.
   * @param offset Number of new bits.
   */
  public SX(final Term vector, final int offset) {
    super(vector, offset);
  }

  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final TermSwitch<? extends Result> v) {
    return v.caseSX(getVector(), getOffset());
  }
}
