package net.afyre.haha.demo.solver.expr.types;

/**
 * Interface of objects used to create atomic types.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public interface AtomicTypeFactory {
  /**
   * Create an atomic type of kind 'Rational'
   * @see AtomicTypeSwitch#caseRational
   * @return Expression object.
   */
  AtomicType createRational();

  /**
   * Create an atomic type of kind 'Int'
   * @see AtomicTypeSwitch#caseInt
   * @return Expression object.
   */
  AtomicType createInt();

  /**
   * Create an atomic type of kind 'Bitvector'
   * @see AtomicTypeSwitch#caseBitvector
   * @param size {@link AtomicTypeSwitch#caseBitvector}
   * @return Expression object.
   */
  AtomicType createBitvector(int size);
}
