package net.afyre.haha.demo.solver.expr.types;

/**
 * Interface of objects used to deconstruct atomic types.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 * @param <Result> Type of objects returned by visitor methods.
 */
public interface AtomicTypeSwitch<Result> {
  /** 
   * Type of rational numbers. 
   * @return Switch result. 
   **/
  Result caseRational();
  
  /** 
   * Type of integers (Z). 
   * @return Switch result. 
   **/
  Result caseInt();
  
  /**
   * Type of bit vectors.
   * @param size Vector length.
   * @return Switch result. 
   **/
  Result caseBitvector(int size);
  
  /* TODO: Subtypes? */
}
