package net.afyre.haha.demo.solver.expr.types;

/**
 * Interface of objects used to create structured types.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public interface StructuredTypeFactory {
  /**
   * Create a structured type of kind 'Array'
   * @see StructuredTypeSwitch#caseArray
   * @param indexType {@link StructuredTypeSwitch#caseArray}
   * @param valueType {@link StructuredTypeSwitch#caseArray}
   * @return Expression object.
   */
  StructuredType createArray(ValueType indexType,
                             ValueType valueType);

  /**
   * Create a structured type of kind 'Tuple'
   * @see StructuredTypeSwitch#caseTuple
   * @param types {@link StructuredTypeSwitch#caseTuple}
   * @return Expression object.
   */
  StructuredType createTuple(ValueType... types);
}
