package net.afyre.haha.demo.solver.expr.types.impl;

import net.afyre.haha.demo.solver.expr.types.NonValueType;
import net.afyre.haha.demo.solver.expr.types.NonValueTypeSwitch;
import net.afyre.haha.demo.solver.expr.types.TypeSwitch;

/**
 * Abstract superclass of non-value types.
 * 
 * Implements forwarding of accept calls for supertypes.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public abstract class AbstractNonValueType extends AbstractType
                                           implements NonValueType {
  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final TypeSwitch<? extends Result> v) {
    return accept((NonValueTypeSwitch<? extends Result>)v); 
  }
}
