package net.afyre.haha.demo.solver.expr.types.impl;

import net.afyre.haha.demo.solver.expr.ExpressionSwitch;
import net.afyre.haha.demo.solver.expr.impl.AbstractExpression;
import net.afyre.haha.demo.solver.expr.types.Type;
import net.afyre.haha.demo.solver.expr.types.TypeSwitch;

/**
 * Abstract superclass of types types.
 * 
 * Implements forwarding of accept calls for supertypes.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public abstract class AbstractType extends AbstractExpression
                                   implements Type {
  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final ExpressionSwitch<? extends Result> v) {
    return accept((TypeSwitch<? extends Result>)v);
  }
}
