package net.afyre.haha.demo.solver.expr.types.impl;

import net.afyre.haha.demo.solver.expr.types.TypeSwitch;
import net.afyre.haha.demo.solver.expr.types.ValueType;
import net.afyre.haha.demo.solver.expr.types.ValueTypeSwitch;

/**
 * Abstract superclass of value types.
 * 
 * Implements forwarding of accept calls for supertypes.
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public abstract class AbstractValueType extends AbstractType
                                        implements ValueType {
  /** {@inheritDoc} */
  @Override
  public<Result> Result accept(final TypeSwitch<? extends Result> v) {
    return accept((ValueTypeSwitch<? extends Result>)v); 
  }
}
