/*
* generated by Xtext
*/
package net.afyre.haha.demo.ui.contentassist;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.jface.resource.ColorRegistry;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.jface.viewers.StyledString;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.xtext.ui.label.StylerFactory;

import com.google.common.base.Joiner;

import net.afyre.haha.demo.haha.Argument;
import net.afyre.haha.demo.haha.ExistsVar;
import net.afyre.haha.demo.haha.ForallVar;
import net.afyre.haha.demo.haha.Function;
import net.afyre.haha.demo.haha.HahaPackage;
import net.afyre.haha.demo.haha.Local;
import net.afyre.haha.demo.haha.Predicate;
import net.afyre.haha.demo.ui.contentassist.AbstractHahaProposalProvider;
import net.afyre.haha.demo.ui.util.Utils;
/**
 * see http://www.eclipse.org/Xtext/documentation/latest/xtext.html#contentAssist on how to customize content assistant
 */
public class HahaProposalProvider extends AbstractHahaProposalProvider {
  final StylerFactory stylerFactory = new StylerFactory();
  
  // TODO: Move this ...
  final ColorRegistry colorRegistry = JFaceResources.getColorRegistry();
  
  final static String TYPE_COLOR = "GLUPIKOLOR";
  final static String TYPE_BG_COLOR = null;
  
  public HahaProposalProvider() {
    colorRegistry.put(TYPE_COLOR, new RGB(0, 0, 255));
  }
  
  @Override
  protected StyledString getStyledDisplayString(final EObject element,
                                                final String qualifiedName, 
                                                final String shortName) {
    final String displayString = 
        getDisplayString(element, qualifiedName, shortName);

    switch (element.eClass().getClassifierID()) {
      case HahaPackage.LOCAL:
        return styleLocal((Local)element, displayString);
      case HahaPackage.ARGUMENT:
        return styleArgument((Argument)element, displayString);
      case HahaPackage.EXISTS_VAR:
        return styleExistsVar((ExistsVar)element, displayString);
      case HahaPackage.FORALL_VAR:
        return styleForallVar((ForallVar)element, displayString);
      case HahaPackage.FUNCTION:
        return styleFunction((Function)element, displayString);
      case HahaPackage.PREDICATE:
        return stylePredicate((Predicate)element, displayString);
      default:
        return new StyledString(displayString);
    }
  }
  
  private StyledString styleLocal(final Local var,
                                  final String text) {
    final StyledString result = new StyledString(text);
    result.append(new StyledString(
        " : " + Utils.typeToString(var.getType()), 
        stylerFactory.createStyler(TYPE_COLOR, TYPE_BG_COLOR)));
    if (var.getDoc() != null) {
      result.append(new StyledString(" - " + var.getDoc(), 
          StyledString.DECORATIONS_STYLER));      
    }
    return result;
  }

  
  private StyledString styleArgument(final Argument arg,
                                     final String text) {
    
    final StyledString result = new StyledString(text);
    result.append(new StyledString(
        " : " + Utils.typeToString(arg.getType()), 
        stylerFactory.createStyler(TYPE_COLOR, TYPE_BG_COLOR)));
    if (arg.getDoc() != null) {
      result.append(new StyledString(" - " + arg.getDoc(), 
          StyledString.DECORATIONS_STYLER));      
    }
    return result;
  }
  
  private StyledString styleExistsVar(final ExistsVar var, 
                                      final String text) {
    final StyledString result = new StyledString(text);
    result.append(
        new StyledString(" : " + Utils.typeToString(var.getType()),
        stylerFactory.createStyler(TYPE_COLOR, TYPE_BG_COLOR)));
    return result;
  }
  
  private StyledString styleForallVar(final ForallVar var, 
                                      final String text) {
    final StyledString result = new StyledString(text);
    result.append(
        new StyledString(" : " + Utils.typeToString(var.getType()),
        stylerFactory.createStyler(TYPE_COLOR, TYPE_BG_COLOR)));
    return result;
  }

  private StyledString styleFunction(final Function func, 
                                     final String text) {
    final StyledString result = new StyledString(text);
    final Joiner joiner = Joiner.on(" → ");
    final List<String> types = new ArrayList<String>();

    for (final Argument arg : func.getArguments().getArguments()) {
      types.add(Utils.typeToString(arg.getType()));
    }
    types.add(Utils.typeToString(func.getResultType()));
    result.append(new StyledString(" : " + joiner.join(types), stylerFactory
        .createStyler(TYPE_COLOR, TYPE_BG_COLOR)));
    return result;
  }
  
  private StyledString stylePredicate(final Predicate pred,
                                      final String text) {
    final StyledString result = new StyledString(text);
    final Joiner joiner = Joiner.on(" → ");
    final List<String> types = new ArrayList<String>();
    
    for (final Argument arg : pred.getArguments().getArguments()) {
      types.add(Utils.typeToString(arg.getType()));
    }
    types.add("BOOL");
    result.append(new StyledString(" : " + joiner.join(types),
        stylerFactory.createStyler(TYPE_COLOR, TYPE_BG_COLOR)));    
    return result;    
  }
}
