package net.afyre.haha.demo.ui.prefs;

import java.net.URL;

import net.afyre.haha.demo.ui.internal.HahaActivator;

import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Path;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

/**
 * Preference page with solver settings.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 *
 */
public class SolverPreferencePage extends FieldEditorPreferencePage implements IWorkbenchPreferencePage  {
  /** Solver path preference name. */
  public static final String PREF_SOLVER_PATH = "SOLVER_PATH";

  public SolverPreferencePage() {
    super("Z3 preferences", FieldEditorPreferencePage.FLAT);
    final URL url = 
        FileLocator.find(HahaActivator.getInstance().getBundle(), 
                         new Path("icons/z3-16x16.gif"), null);
    final ImageDescriptor image = ImageDescriptor.createFromURL(url);
    setImageDescriptor(image);
  }
  
  /** {@inheritDoc} */
  @Override
  protected void createFieldEditors() {
    final Composite parent = getFieldEditorParent();

    addField(new ExecutableFieldEditor(PREF_SOLVER_PATH, "Z3 executable:", parent));
  }
  
  /** {@inheritDoc} */
  @Override
  public void init(IWorkbench workbench) {
    setPreferenceStore(HahaActivator.getInstance().getPreferenceStore());
  }
  
}
