package net.afyre.haha.demo.types;

/**
 * Interface of objects used to inspect atomic types.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 * 
 * @param <Result> Type of inspection result.
 */
public interface AtomicTypeSwitch<Result> {
  /**
   * Arbitrary-precision integer.
   * @return Result.
   */
  Result caseZ();

  /**
   * 32-bit integer.
   * @return Result.
   */
  Result caseInteger();
  
  /** 
   * Logical value.
   * @return Result.
   */
  Result caseBoolean();
}
