package net.afyre.haha.demo.vcgen;

import java.util.ArrayList;
import java.util.List;

import com.google.common.collect.ImmutableList;

/**
 * Object used to collect verification conditions.
 * 
 * @author Tadeusz Sznuk <tsznuk@mimuw.edu.pl>
 */
public class VCCollector implements VCConsumer {
  /** Collected conditions. */
  private final 
  List<VerificationCondition> conditions;
  
  /** Constructor. */
  public VCCollector() {
    conditions = 
        new ArrayList<VerificationCondition>();
  }
  
  /** {@inheritDoc} */
  @Override
  public void processVerificationCondition(
      final VerificationCondition vc) {
    conditions.add(vc);
  }

  /**
   * Get all collected conditions.
   * @return List of conditions.
   */
  public List<VerificationCondition> getConditions() {
    return ImmutableList.copyOf(conditions);
  }
}
